#include <iostream>
#include <string>
using namespace std;

class Cripto {
private:
    int k;
public:
    Cripto( int k ) {
        setKey( k );
    }
    
    void setKey( int k ) {
        if( k >= 0 && k <= 25 )
            this->k = k;
        else
            this->k = 0;
    } 
    
    int getKey() {
        return k;
    }
    
    string encrypt( string in ) {
        string out( in );
        for( int i =0; i < out.size(); i++ ) {
            out[i] = out[i] + k; 
            if( out[i] > 255 )
                out[i] = out[i] - 256;
        }
        return out;
    }
    
    string decrypt( string in ) {
        string out( in );
        for( int i =0; i < out.size(); i++ ) {
            out[i] = out[i] - k; 
            if( out[i] < 0 )
                out[i] = out[i] + 256;
        }
        return out;
    }
};

int main() {
    string in;
    int k;
    cout << "Entre com a palavra: ";
    getline( cin, in );
    cout << "Entre com a chave: ";
    cin >> k;
    Cripto cripto( k );
    string out = cripto.encrypt( in );
    cout << "Texto Criptografado: " << out << endl;
    string dec = cripto.decrypt( out );
    cout << "Texto decriptografado: " << dec << endl;   
}
